/***************************************************************************
 *   Copyright (C) 2006 by PhobosK   *
 *   phobosk@mail.kbfx.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KBFXKIODOWNLOAD_H
#define KBFXKIODOWNLOAD_H

#include <kio/job.h>
#include <ktempfile.h>
#include <kdebug.h>

/**
	@author PhobosK <phobosk@mail.kbfx.org>
*/
class KbfxKioDownload: public QObject
{
    Q_OBJECT
public:
        KbfxKioDownload(QObject * parent = 0, const char * name = 0);

        ~KbfxKioDownload();
	
	// Invocation of KbfxKioDownload - pass an url as QString
	void KbfxKioDownloadStart(QString &url);

	// Return the name of the temp file for the download
	QString KbfxBrowserTmpFile() {return m_KbfxBrowserTmpFile;}
	
	// Return the error number  that occured during download - see Definition at file global.h
	int KbfxBrowserError() {return m_KbfxBrowserError;}
	
	// Return the error text that occured during download
	QString KbfxBrowserErrorText() {return m_KbfxBrowserErrorText;}

protected:
	QString m_KbfxBrowserTmpFile; 
	int m_KbfxBrowserError; 
	QString m_KbfxBrowserErrorText;
	
private:
	KTempFile tmpF;

public slots:
    // Call when you are ready to delete the temp file for the download
    virtual void KbfxKioDownloadEnd();
    
private slots:
	// The actual job done here
	virtual void KbfxBrowserResult(KIO::Job *);

signals:
	// Emitted when the download is ready
	void KbfxKioDownloadReady();

};

#endif
